/**
*	GraphCanvas.java
*	Ot\LoX
*/

import	java.awt.*;
import	java.util.*;

class	GraphCanvas	extends Canvas
{
	int	width, height;
	double	minX, minY;
	double	scaleX, scaleY;
	
	protected Vector	Points = new Vector();
	protected Vector	Lines  = new Vector();
	protected Vector	PolyLines = new Vector();

	/**
	*	\Ci[NX
	*/
	class	aLine
	{
		Point	p1, p2;	
		
		public	aLine( int x1, int y1, int x2, int y2 )
		{	p1 = new Point( x1, y1 );
			p2 = new Point( x2, y2 );
		}
	}
	
	/**
	*	RXgN^[
	*	@param	int	ʂ̕
	*	@param	int	ʂ̍
	*/
	public	GraphCanvas( int w0, int h0 )
	{
		super();
		setBackground( Color.black );
		
		setSize( width = w0, height = h0 );
		
		minX = - width / 2;		minY = - height / 2;
		scaleX = 1.0;		scaleY = 1.0;
	}
	
	/**
	*	Ot͈̔͂ݒ肷
	*	@param	double	X̍ŏ͈
	*	@param	double	X̍ő͈
	*	@param	double	Y̍ŏ͈
	*	@param	double	Y̍ő͈
	*/
	public void	setRange( double min_x, double max_x, double min_y, double max_y )
	{
		double	dx = max_x - min_x;
		double	dy = max_y - min_y;
		
		if( dx < 0 ){ dx = -dx; }
		if( dy < 0 ){ dy = -dy; }
		
		scaleX =    width / dx;
		scaleY = - height / dy;
		
		minX = min_x;
		minY = min_y;
	}

	/**
	*	ʂSď
	*/
	public void	clearAll()
	{
		Points.removeAllElements();
		Lines.removeAllElements();
		PolyLines.removeAllElements();
		repaint();
	}
	
	/**
	*	_ł
	*	@param	double	XW
	*	@param	double	YW
	*/
	public void	plotPoint( double x, double y )
	{
		int	px = (int)( (x - minX) * scaleX );
		int	py = (int)( (y - minY) * scaleY ) + height;
		
		Point	p = new Point( px, py );
		
		Points.addElement( p );
		
		repaint( px-2, py-2, 4, 4 );
	}

	/**
	*	
	*	@param	double	_1XW
	*	@param	double	_1YW
	*	@param	double	_2XW
	*	@param	double	_2YW
	*/
	public void	drawLine( double x1, double y1, double x2, double y2 )
	{
		int	lx1 = (int)( (x1 - minX) * scaleX );
		int	ly1 = (int)( (y1 - minY) * scaleY ) + height;
		int	lx2 = (int)( (x2 - minX) * scaleX );
		int	ly2 = (int)( (y2 - minY) * scaleY ) + height;
		
		aLine	line = new aLine( lx1, ly1, lx2, ly2 );
		
		Lines.addElement( line );
		
		int	w = lx1 - lx2;	if( w < 0 ){ w = -w; }
		int	h = ly1 - ly2;	if( h < 0 ){ h = -h; }
		repaint( lx1, ly1, w+1, h+1 );
	}

	/**
	*	A̐܂Ƃ߂Ĉ
	*	@param	Vector	_̃XgAXg̓e x, yW̓ double[2]
	*/
	public void	drawPolyLine( Vector points )
	{
		double[]	p1 = null, p2 = null;
		int		lx1 = 0, lx2 = 0, ly1 = 0, ly2 = 0;
		Vector	poly = new Vector();
		
		Enumeration e = points.elements();
		if( e.hasMoreElements() )
		{
			p1 = (double[])e.nextElement();	// Pڂo
		}
		while( e.hasMoreElements() )
		{
			p2 = (double[])e.nextElement();
			
			lx1 = (int)( (p1[0] - minX) * scaleX );
			ly1 = (int)( (p1[1] - minY) * scaleY ) + height;
			lx2 = (int)( (p2[0] - minX) * scaleX );
			ly2 = (int)( (p2[1] - minY) * scaleY ) + height;
			
			poly.addElement( new Point(lx1, ly1) );
			
		// -- ǂSɂ䂩Ȃ...
		//	int	w = lx1 - lx2;	if( w < 0 ){ w = -w; }
		//	int	h = ly1 - ly2;	if( h < 0 ){ h = -h; }
		//	repaint( lx1, ly1, w+1, h+1 );
			
			p1 = p2;	// ̏
		}
		if( p2 != null ) // o^ׂ
		{	poly.addElement( new Point(lx2, ly2) );	// Ō̓_o^
			PolyLines.addElement( poly );
		}
		repaint(); // Sʍĕ`悪m
	}
	
	/**
	*	`悷
	*/
	public void	paint( Graphics g )
	{
		// 10
		g.setColor( new Color( 0x00, 0x00, 0x80 ) );
		for( int i=0; i <=10; i++ )
		{	int	dy = height * i / 10;
			g.drawLine( 0, dy, width, dy );
		}
		for( int i=0; i <=10; i++ )
		{	int	dx = width * i / 10;
			g.drawLine( dx, 0, dx, height );
		}
		
		// S
		g.setColor( Color.blue );
		g.drawLine( 0, height/2, width, height/2 );
		g.drawLine( width/2, 0, width/2, height );
		
		// _ł
		g.setColor( Color.red );
		for( Enumeration e = Points.elements() ; e.hasMoreElements() ; )
		{	Point	p = (Point)e.nextElement();
			g.fillOval( p.x -2, p.y -2, 4, 4 );
			
		}
		
		// 
		g.setColor( Color.green );
		for( Enumeration e = Lines.elements() ; e.hasMoreElements() ; )
		{	aLine	line = (aLine)e.nextElement();
			g.drawLine( line.p1.x, line.p1.y, line.p2.x, line.p2.y );
		}
		
		// A̐
		for( Enumeration e = PolyLines.elements() ; e.hasMoreElements() ; )
		{
			Vector	poly = (Vector)e.nextElement();
			Enumeration e2 = poly.elements() ;
			Point	p1 = null, p2 = null;
			if( e2.hasMoreElements() )
			{	p1 = (Point)e2.nextElement();
			}
			int	i=1;
			while( e2.hasMoreElements() )
			{	p2 = (Point)e2.nextElement();
				g.drawLine( p1.x, p1.y, p2.x, p2.y );
				p1 = p2;
				i++;
			}
		}
	}
}

/*--- End of File -----------------------------------------------------------*/
